# Engineer bind creator
# Made for Disatrous Consequences UT2004 invasion server.: http://www.disastrousconsequences.com
# By Greg11
# Updated: 21 November 2009

import sys

INVPREV='InventoryPrevious'
START='SelectShieldBlast'
BIND_PREFIX = 'eng_bind_'
BIND_EXT='txt'
KILLERS=['kill_buildings',
         'kill_turrets',
         'kill_vehicles',
         'kill_sents' ]

def getconstdata():
    data=[]
    file=open('engconstructs.txt')
    for line in file:
        line=line.strip()
        if line:
            # Ignore comments
            if line.startswith('#'):continue
            if '#' in line:
                line=line.split('#')[0]

            data.append( [ d.strip() for d in line.split(',') ] )

    return data

def availconstructs(lvl,data):
    availdata=[]
    for d in data:
        if len(d)<2:continue # In case data is bad
        if d[1].isdigit and int(d[1]) <= lvl: availdata.append(d)
    return availdata

def makekillers():
    i=0
    for killer in KILLERS:
       i+=1
       strlist=[START]+[INVPREV]*i
       filename=BIND_PREFIX+killer+'.'+BIND_EXT
       open(filename,'w').write('\n'.join(strlist))

def makelistheader():
    return [START]+[INVPREV]*len(KILLERS)

def cleanname(str):
    #replace spaces with underscores
    return str.replace(' ','_')

def makebinds(availdata):
    strlist = [START]+[INVPREV]*len(KILLERS)
    for d in availdata:
        filename = BIND_PREFIX + cleanname(d[0]) + '.' + BIND_EXT
        strlist += [INVPREV]
        open(filename,'w').write('\n'.join(strlist))
 

def main():
    import os
    data = getconstdata()
    for lvl in range(1,16):
        os.mkdir(str(lvl))
        os.chdir(str(lvl))
        availdata = availconstructs(lvl,data)
        makekillers()
        makebinds(availdata)
        os.chdir('..')
        
    
main()
